/*

  File Inversa.ccp:

  inverte una matrice 3 x 3
  utilizzando la fattorizzazione LU

*/


#include <iostream>
using namespace std;

#include "LUmat.h"


main()
{
  cout << "Calcolo della soluzione di un sistema tramite fattorizzazione LU" << endl;

  const int N = 3;
  double mat[N][N] = { { 3.0, 2.0, 1.0 },
		       { 4.0, 5.0, 2.0 },
		       { 1.0, 2.0, 3.0 } };
  double inv[N][N] = { { 0.0, 0.0, 0.0 },
		       { 0.0, 0.0, 0.0 },
		       { 0.0, 0.0, 0.0 } };


  // Stampa sullo schermo la matrice iniziale

  cout << "Matrice iniziale:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      for ( int j = 0; j < N; j++ ) cout << "   " << mat[i][j];
      cout << endl;
    }

  // Crea l'oggetto matrice, lo inizializza e lo fattorizza LU

  LUmat matrice = LUmat( N );
  matrice.setMatrix( &mat[0][0] );
  matrice.luFact( );


  // Per ogni colonna dell'inversa, costruisce i secondi membri del sistema
  // e trova l'inversa

  double x[N];
  double sm[N];

  for ( int ism = 0; ism < N; ism ++ )
    {
      for ( int i = 0; i < N; i++ ) sm[i] = 0.0;
      sm[ism] = 1.0;
      matrice.luSolve( x, sm );
      for ( int i = 0; i < N; i++ ) inv[i][ism] = x[i];
    }


  // Stampa della matrice inversa sullo schermo

  cout << "Matrice inversa:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      for ( int j = 0; j < N; j++ ) cout << "   " << inv[i][j];
      cout << endl;
    }


  // Verifica del risultato

  cout << "Prodotto matrice per inversa:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      for ( int j = 0; j < N; j++ )
         {
          double sum = 0.0;
          for ( int k = 0; k < N; k++ ) sum += mat[i][k] * inv[k][j];
          cout << "   " << sum;
         }
      cout << endl;
    }

  cout << "Prodotto inversa per matrice:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      for ( int j = 0; j < N; j++ )
         {
          double sum = 0.0;
          for ( int k = 0; k < N; k++ ) sum += inv[i][k] * mat[k][j];
          cout << "   " << sum;
         }
      cout << endl;
    }

}
