/*

  File sistema.ccp:

  inverte un sistema 3 x 3 data la matrice e il vettore dei secondi membri
  utilizzando la fattorizzazione LU

*/


#include <iostream>
using namespace std;

#include "LUmat.h"


main()
{
  cout << "Calcolo della soluzione di un sistema tramite fattorizzazione LU" << endl;

  const int N = 3;
  double mat[N][N] = { { 3.0, 2.0, 1.0 },
		       { 4.0, 5.0, 2.0 },
		       { 1.0, 2.0, 3.0 } };


  // Stampa sullo schermo la matrice iniziale

  cout << "Matrice iniziale:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      for ( int j = 0; j < N; j++ ) cout << "   " << mat[i][j];
      cout << endl;
    }


  // Crea l'oggetto matrice, lo inizializza ed esegue la fattorizzazione LU

  LUmat matrice = LUmat( N );
  matrice.setMatrix( &mat[0][0] );
  matrice.luFact( );


  // Stampa sullo schermo la matrice fattorizzata LU per verifica

  cout << "Matrice fattorizzata LU:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      for ( int j = 0; j < N; j++ ) cout << "   " << matrice.getElement( i, j );
      cout << endl;
    }


  // Costruisce i secondi membri del sistema

  double x[N];
  double sm[N];

  for ( int i = 0; i < N; i++ )
    {
      sm[i] = i * 1.0;
    }


  // Stampa sullo schermo il vettore del secondo membro

  cout << "Vettore del secondo membro:" << endl;
  for ( int i = 0; i < N; i++ ) cout << "   " << sm[i];
  cout << endl;


  // Inverte il sistema fattorizzato LU

  matrice.luSolve( x, sm );


  // Verifica del risultato

  cout << "Verifica del risultato." << endl;
  cout << "Prodotto matrice per vettore soluzione:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      double sum = 0.0;
      for ( int j = 0; j < N; j++ ) sum += mat[i][j] * x[j];
      cout << "   " << sum;
    }
  cout << endl;

}
