/*

  File Tridiag.ccp:

  inverte un sistema 3 x 3 di un problema tridiagonale
  utilizzando l'algoritmo di Thomas per la fattorizzazione LU

*/


#include <iostream>
#include "LUtrid.h"
using namespace std;


main()
{
  cout << "Calcolo della soluzione di un sistema tridiagonale tramite fattorizzazione LU" << endl;

  const int N = 3;
  double a[N][N] = { { 4.0, 1.0, 0.0 },
		     { 2.0, 5.0, 2.0 },
		     { 0.0, 1.0, 2.0 } };
  // Scommentare per inizializzazione della matrice per diagonali
  /*
  double bb[N] = { 0.0, 2.0, 1.0 };
  double aa[N] = { 4.0, 5.0, 2.0 };
  double cc[N] = { 1.0, 2.0, 0.0 };
  */

  // Costruisce l'oggetto matrice della classe LUtrid

  LUtrid matrice = LUtrid( N );

  // Inizializza l'oggetto con la matrice
  // Scommentare per inizializzazione della matrice per elementi
  ///*
  for ( int i = 0; i < N; i++ )
    for ( int j = 0; j < N; j++ )
      matrice.setElement( i, j, a[i][j] );
  //*/
  // Scommentare per inizializzazione della matrice per diagonali
  /*
  matrice.setDiagonal( bb, aa, cc );
  */

  // Stampa sullo schermo la matrice iniziale

  cout.precision( 15 );
  cout << "Matrice iniziale:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      for ( int j = 0; j < N; j++ ) cout << "   " << a[i][j];
      cout << endl;
    }

  matrice.luFact( );


  // Costruisce i secondi membri del sistema

  double x[N];
  double sm[N];

  for ( int i = 0; i < N; i++ )
    {
      sm[i] = i * 1.0;
    }


  // Stampa sullo schermo il vettore del secondo membro

  cout << "Vettore del secondo membro:" << endl;
  for ( int i = 0; i < N; i++ ) cout << "   " << sm[i];
  cout << endl;


  // Inverte il sistema fattorizzato LU

  matrice.luSolve( x, sm );


  // Stampa del risultato

  cout << "Vettore soluzione:" << endl;
  for ( int i = 0; i < N; i++ )
    {
      cout << "   " << x[i];
    }
  cout << endl;

  // Verifica del risultato

  cout << "Prodotto riga per colonna della matrice iniziale per soluzione" << endl;
  for ( int i = 0; i < N; i++ )
    {
      double sum = 0.0;
      for ( int j = 0; j < N; j++ ) sum += a[i][j] * x[j];
      cout << sum << endl;
    }
}
